DescriptorProtos.DescriptorProto
Date: 2017-07-08

com.google.protobuf

## Class DescriptorProtos.DescriptorProto

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite
  - - com.google.protobuf.AbstractMessage
    - - com.google.protobuf.GeneratedMessageV3
      - - com.google.protobuf.DescriptorProtos.DescriptorProto

- All Implemented Interfaces:
    DescriptorProtos.DescriptorProtoOrBuilder, Message, MessageLite, MessageLiteOrBuilder, MessageOrBuilder, java.io.Serializable
  Enclosing class:
    DescriptorProtos

      public static final class DescriptorProtos.DescriptorProto
      extends GeneratedMessageV3
      implements DescriptorProtos.DescriptorProtoOrBuilder

       Describes a message type.

  Protobuf type `google.protobuf.DescriptorProto`
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DescriptorProtos.DescriptorProto.Builder` Describes a message type.
    `static class` | `DescriptorProtos.DescriptorProto.ExtensionRange` Protobuf type `google.protobuf.DescriptorProto.ExtensionRange`
    `static interface` | `DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder`
    `static class` | `DescriptorProtos.DescriptorProto.ReservedRange` Range of reserved tag numbers.
    `static interface` | `DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder`

    - ### Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessageV3

      `GeneratedMessageV3.BuilderParent, GeneratedMessageV3.ExtendableBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage,BuilderType extends GeneratedMessageV3.ExtendableBuilder<MessageType,BuilderType>>, GeneratedMessageV3.ExtendableMessage<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.FieldAccessorTable`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ENUM_TYPE_FIELD_NUMBER`
    `static int` | `EXTENSION_FIELD_NUMBER`
    `static int` | `EXTENSION_RANGE_FIELD_NUMBER`
    `static int` | `FIELD_FIELD_NUMBER`
    `static int` | `NAME_FIELD_NUMBER`
    `static int` | `NESTED_TYPE_FIELD_NUMBER`
    `static int` | `ONEOF_DECL_FIELD_NUMBER`
    `static int` | `OPTIONS_FIELD_NUMBER`
    `static Parser<DescriptorProtos.DescriptorProto>` | `PARSER` Deprecated.
    `static int` | `RESERVED_NAME_FIELD_NUMBER`
    `static int` | `RESERVED_RANGE_FIELD_NUMBER`

    - ### Fields inherited from class com.google.protobuf.GeneratedMessageV3

      `alwaysUseFieldBuilders, unknownFields`

    - ### Fields inherited from class com.google.protobuf.AbstractMessage

      `memoizedSize`

    - ### Fields inherited from class com.google.protobuf.AbstractMessageLite

      `memoizedHashCode`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)` Compares the specified object with this message for equality.
    `static DescriptorProtos.DescriptorProto` | `getDefaultInstance()`
    `DescriptorProtos.DescriptorProto` | `getDefaultInstanceForType()` Get an instance of the type with no fields set.
    `static Descriptors.Descriptor` | `getDescriptor()`
    `DescriptorProtos.EnumDescriptorProto` | `getEnumType(int index)` `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
    `int` | `getEnumTypeCount()` `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
    `java.util.List<DescriptorProtos.EnumDescriptorProto>` | `getEnumTypeList()` `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
    `DescriptorProtos.EnumDescriptorProtoOrBuilder` | `getEnumTypeOrBuilder(int index)` `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
    `java.util.List<? extends DescriptorProtos.EnumDescriptorProtoOrBuilder>` | `getEnumTypeOrBuilderList()` `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
    `DescriptorProtos.FieldDescriptorProto` | `getExtension(int index)` `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
    `int` | `getExtensionCount()` `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
    `java.util.List<DescriptorProtos.FieldDescriptorProto>` | `getExtensionList()` `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
    `DescriptorProtos.FieldDescriptorProtoOrBuilder` | `getExtensionOrBuilder(int index)` `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
    `java.util.List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder>` | `getExtensionOrBuilderList()` `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
    `DescriptorProtos.DescriptorProto.ExtensionRange` | `getExtensionRange(int index)` `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
    `int` | `getExtensionRangeCount()` `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
    `java.util.List<DescriptorProtos.DescriptorProto.ExtensionRange>` | `getExtensionRangeList()` `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
    `DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder` | `getExtensionRangeOrBuilder(int index)` `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
    `java.util.List<? extends DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder>` | `getExtensionRangeOrBuilderList()` `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
    `DescriptorProtos.FieldDescriptorProto` | `getField(int index)` `repeated .google.protobuf.FieldDescriptorProto field = 2;`
    `int` | `getFieldCount()` `repeated .google.protobuf.FieldDescriptorProto field = 2;`
    `java.util.List<DescriptorProtos.FieldDescriptorProto>` | `getFieldList()` `repeated .google.protobuf.FieldDescriptorProto field = 2;`
    `DescriptorProtos.FieldDescriptorProtoOrBuilder` | `getFieldOrBuilder(int index)` `repeated .google.protobuf.FieldDescriptorProto field = 2;`
    `java.util.List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder>` | `getFieldOrBuilderList()` `repeated .google.protobuf.FieldDescriptorProto field = 2;`
    `java.lang.String` | `getName()` `optional string name = 1;`
    `ByteString` | `getNameBytes()` `optional string name = 1;`
    `DescriptorProtos.DescriptorProto` | `getNestedType(int index)` `repeated .google.protobuf.DescriptorProto nested_type = 3;`
    `int` | `getNestedTypeCount()` `repeated .google.protobuf.DescriptorProto nested_type = 3;`
    `java.util.List<DescriptorProtos.DescriptorProto>` | `getNestedTypeList()` `repeated .google.protobuf.DescriptorProto nested_type = 3;`
    `DescriptorProtos.DescriptorProtoOrBuilder` | `getNestedTypeOrBuilder(int index)` `repeated .google.protobuf.DescriptorProto nested_type = 3;`
    `java.util.List<? extends DescriptorProtos.DescriptorProtoOrBuilder>` | `getNestedTypeOrBuilderList()` `repeated .google.protobuf.DescriptorProto nested_type = 3;`
    `DescriptorProtos.OneofDescriptorProto` | `getOneofDecl(int index)` `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
    `int` | `getOneofDeclCount()` `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
    `java.util.List<DescriptorProtos.OneofDescriptorProto>` | `getOneofDeclList()` `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
    `DescriptorProtos.OneofDescriptorProtoOrBuilder` | `getOneofDeclOrBuilder(int index)` `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
    `java.util.List<? extends DescriptorProtos.OneofDescriptorProtoOrBuilder>` | `getOneofDeclOrBuilderList()` `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
    `DescriptorProtos.MessageOptions` | `getOptions()` `optional .google.protobuf.MessageOptions options = 7;`
    `DescriptorProtos.MessageOptionsOrBuilder` | `getOptionsOrBuilder()` `optional .google.protobuf.MessageOptions options = 7;`
    `Parser<DescriptorProtos.DescriptorProto>` | `getParserForType()` Gets the parser for a message of the same type as this message.
    `java.lang.String` | `getReservedName(int index)` Reserved field names, which may not be used by fields in the same message.
    `ByteString` | `getReservedNameBytes(int index)` Reserved field names, which may not be used by fields in the same message.
    `int` | `getReservedNameCount()` Reserved field names, which may not be used by fields in the same message.
    `ProtocolStringList` | `getReservedNameList()` Reserved field names, which may not be used by fields in the same message.
    `DescriptorProtos.DescriptorProto.ReservedRange` | `getReservedRange(int index)` `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
    `int` | `getReservedRangeCount()` `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
    `java.util.List<DescriptorProtos.DescriptorProto.ReservedRange>` | `getReservedRangeList()` `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
    `DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder` | `getReservedRangeOrBuilder(int index)` `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
    `java.util.List<? extends DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder>` | `getReservedRangeOrBuilderList()` `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
    `int` | `getSerializedSize()` Get the number of bytes required to encode this message.
    `UnknownFieldSet` | `getUnknownFields()` Get the `UnknownFieldSet` for this message.
    `int` | `hashCode()` Returns the hash code value for this message.
    `boolean` | `hasName()` `optional string name = 1;`
    `boolean` | `hasOptions()` `optional .google.protobuf.MessageOptions options = 7;`
    `protected GeneratedMessageV3.FieldAccessorTable` | `internalGetFieldAccessorTable()` Get the FieldAccessorTable for this type.
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `static DescriptorProtos.DescriptorProto.Builder` | `newBuilder()`
    `static DescriptorProtos.DescriptorProto.Builder` | `newBuilder(DescriptorProtos.DescriptorProto prototype)`
    `DescriptorProtos.DescriptorProto.Builder` | `newBuilderForType()` Constructs a new builder for a message of the same type as this message.
    `protected DescriptorProtos.DescriptorProto.Builder` | `newBuilderForType(GeneratedMessageV3.BuilderParent parent)` TODO(xiaofeng): remove this together with GeneratedMessageV3.BuilderParent.
    `static DescriptorProtos.DescriptorProto` | `parseDelimitedFrom(java.io.InputStream input)`
    `static DescriptorProtos.DescriptorProto` | `parseDelimitedFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(byte[] data)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(java.nio.ByteBuffer data)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(java.nio.ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(ByteString data)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(CodedInputStream input)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(java.io.InputStream input)`
    `static DescriptorProtos.DescriptorProto` | `parseFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
    `static Parser<DescriptorProtos.DescriptorProto>` | `parser()`
    `DescriptorProtos.DescriptorProto.Builder` | `toBuilder()` Constructs a builder initialized with the current message.
    `void` | `writeTo(CodedOutputStream output)` Serializes the message and writes it to `output`.

    - ### Methods inherited from class com.google.protobuf.GeneratedMessageV3

      `computeStringSize, computeStringSizeNoTag, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof, internalGetMapField, makeExtensionsImmutable, newBuilderForType, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

    - ### Methods inherited from class com.google.protobuf.AbstractMessage

      `findInitializationErrors, getInitializationErrorString, hashBoolean, hashEnum, hashEnumList, hashFields, hashLong, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite

      `addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.MessageLite

      `toByteArray, toByteString, writeDelimitedTo, writeTo`

- - ### Field Detail

    - #### NAME_FIELD_NUMBER

          public static final int NAME_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### FIELD_FIELD_NUMBER

          public static final int FIELD_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### EXTENSION_FIELD_NUMBER

          public static final int EXTENSION_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### NESTED_TYPE_FIELD_NUMBER

          public static final int NESTED_TYPE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### ENUM_TYPE_FIELD_NUMBER

          public static final int ENUM_TYPE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### EXTENSION_RANGE_FIELD_NUMBER

          public static final int EXTENSION_RANGE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### ONEOF_DECL_FIELD_NUMBER

          public static final int ONEOF_DECL_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### OPTIONS_FIELD_NUMBER

          public static final int OPTIONS_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### RESERVED_RANGE_FIELD_NUMBER

          public static final int RESERVED_RANGE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### RESERVED_NAME_FIELD_NUMBER

          public static final int RESERVED_NAME_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### PARSER

          @Deprecated
          public static final Parser<DescriptorProtos.DescriptorProto> PARSER

      Deprecated.

  - ### Method Detail

    - #### getUnknownFields

          public final UnknownFieldSet getUnknownFields()

      Description copied from interface: `MessageOrBuilder`
      Get the `UnknownFieldSet` for this message.
      Specified by:
        `getUnknownFields` in interface `MessageOrBuilder`
      Overrides:
        `getUnknownFields` in class `GeneratedMessageV3`

    - #### getDescriptor

          public static final Descriptors.Descriptor getDescriptor()

    - #### internalGetFieldAccessorTable

          protected GeneratedMessageV3.FieldAccessorTable internalGetFieldAccessorTable()

      Description copied from class: `GeneratedMessageV3`
      Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.
      Specified by:
        `internalGetFieldAccessorTable` in class `GeneratedMessageV3`

    - #### hasName

          public boolean hasName()

      `optional string name = 1;`
      Specified by:
        `hasName` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getName

          public java.lang.String getName()

      `optional string name = 1;`
      Specified by:
        `getName` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getNameBytes

          public ByteString getNameBytes()

      `optional string name = 1;`
      Specified by:
        `getNameBytes` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getFieldList

          public java.util.List<DescriptorProtos.FieldDescriptorProto> getFieldList()

      `repeated .google.protobuf.FieldDescriptorProto field = 2;`
      Specified by:
        `getFieldList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getFieldOrBuilderList

          public java.util.List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder> getFieldOrBuilderList()

      `repeated .google.protobuf.FieldDescriptorProto field = 2;`
      Specified by:
        `getFieldOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getFieldCount

          public int getFieldCount()

      `repeated .google.protobuf.FieldDescriptorProto field = 2;`
      Specified by:
        `getFieldCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getField

          public DescriptorProtos.FieldDescriptorProto getField(int index)

      `repeated .google.protobuf.FieldDescriptorProto field = 2;`
      Specified by:
        `getField` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getFieldOrBuilder

          public DescriptorProtos.FieldDescriptorProtoOrBuilder getFieldOrBuilder(int index)

      `repeated .google.protobuf.FieldDescriptorProto field = 2;`
      Specified by:
        `getFieldOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionList

          public java.util.List<DescriptorProtos.FieldDescriptorProto> getExtensionList()

      `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
      Specified by:
        `getExtensionList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionOrBuilderList

          public java.util.List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder> getExtensionOrBuilderList()

      `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
      Specified by:
        `getExtensionOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionCount

          public int getExtensionCount()

      `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
      Specified by:
        `getExtensionCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtension

          public DescriptorProtos.FieldDescriptorProto getExtension(int index)

      `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
      Specified by:
        `getExtension` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionOrBuilder

          public DescriptorProtos.FieldDescriptorProtoOrBuilder getExtensionOrBuilder(int index)

      `repeated .google.protobuf.FieldDescriptorProto extension = 6;`
      Specified by:
        `getExtensionOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getNestedTypeList

          public java.util.List<DescriptorProtos.DescriptorProto> getNestedTypeList()

      `repeated .google.protobuf.DescriptorProto nested_type = 3;`
      Specified by:
        `getNestedTypeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getNestedTypeOrBuilderList

          public java.util.List<? extends DescriptorProtos.DescriptorProtoOrBuilder> getNestedTypeOrBuilderList()

      `repeated .google.protobuf.DescriptorProto nested_type = 3;`
      Specified by:
        `getNestedTypeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getNestedTypeCount

          public int getNestedTypeCount()

      `repeated .google.protobuf.DescriptorProto nested_type = 3;`
      Specified by:
        `getNestedTypeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getNestedType

          public DescriptorProtos.DescriptorProto getNestedType(int index)

      `repeated .google.protobuf.DescriptorProto nested_type = 3;`
      Specified by:
        `getNestedType` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getNestedTypeOrBuilder

          public DescriptorProtos.DescriptorProtoOrBuilder getNestedTypeOrBuilder(int index)

      `repeated .google.protobuf.DescriptorProto nested_type = 3;`
      Specified by:
        `getNestedTypeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getEnumTypeList

          public java.util.List<DescriptorProtos.EnumDescriptorProto> getEnumTypeList()

      `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
      Specified by:
        `getEnumTypeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getEnumTypeOrBuilderList

          public java.util.List<? extends DescriptorProtos.EnumDescriptorProtoOrBuilder> getEnumTypeOrBuilderList()

      `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
      Specified by:
        `getEnumTypeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getEnumTypeCount

          public int getEnumTypeCount()

      `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
      Specified by:
        `getEnumTypeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getEnumType

          public DescriptorProtos.EnumDescriptorProto getEnumType(int index)

      `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
      Specified by:
        `getEnumType` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getEnumTypeOrBuilder

          public DescriptorProtos.EnumDescriptorProtoOrBuilder getEnumTypeOrBuilder(int index)

      `repeated .google.protobuf.EnumDescriptorProto enum_type = 4;`
      Specified by:
        `getEnumTypeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionRangeList

          public java.util.List<DescriptorProtos.DescriptorProto.ExtensionRange> getExtensionRangeList()

      `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
      Specified by:
        `getExtensionRangeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionRangeOrBuilderList

          public java.util.List<? extends DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder> getExtensionRangeOrBuilderList()

      `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
      Specified by:
        `getExtensionRangeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionRangeCount

          public int getExtensionRangeCount()

      `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
      Specified by:
        `getExtensionRangeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionRange

          public DescriptorProtos.DescriptorProto.ExtensionRange getExtensionRange(int index)

      `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
      Specified by:
        `getExtensionRange` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getExtensionRangeOrBuilder

          public DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder getExtensionRangeOrBuilder(int index)

      `repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;`
      Specified by:
        `getExtensionRangeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOneofDeclList

          public java.util.List<DescriptorProtos.OneofDescriptorProto> getOneofDeclList()

      `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
      Specified by:
        `getOneofDeclList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOneofDeclOrBuilderList

          public java.util.List<? extends DescriptorProtos.OneofDescriptorProtoOrBuilder> getOneofDeclOrBuilderList()

      `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
      Specified by:
        `getOneofDeclOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOneofDeclCount

          public int getOneofDeclCount()

      `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
      Specified by:
        `getOneofDeclCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOneofDecl

          public DescriptorProtos.OneofDescriptorProto getOneofDecl(int index)

      `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
      Specified by:
        `getOneofDecl` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOneofDeclOrBuilder

          public DescriptorProtos.OneofDescriptorProtoOrBuilder getOneofDeclOrBuilder(int index)

      `repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8;`
      Specified by:
        `getOneofDeclOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### hasOptions

          public boolean hasOptions()

      `optional .google.protobuf.MessageOptions options = 7;`
      Specified by:
        `hasOptions` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOptions

          public DescriptorProtos.MessageOptions getOptions()

      `optional .google.protobuf.MessageOptions options = 7;`
      Specified by:
        `getOptions` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getOptionsOrBuilder

          public DescriptorProtos.MessageOptionsOrBuilder getOptionsOrBuilder()

      `optional .google.protobuf.MessageOptions options = 7;`
      Specified by:
        `getOptionsOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedRangeList

          public java.util.List<DescriptorProtos.DescriptorProto.ReservedRange> getReservedRangeList()

      `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
      Specified by:
        `getReservedRangeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedRangeOrBuilderList

          public java.util.List<? extends DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder> getReservedRangeOrBuilderList()

      `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
      Specified by:
        `getReservedRangeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedRangeCount

          public int getReservedRangeCount()

      `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
      Specified by:
        `getReservedRangeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedRange

          public DescriptorProtos.DescriptorProto.ReservedRange getReservedRange(int index)

      `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
      Specified by:
        `getReservedRange` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedRangeOrBuilder

          public DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder getReservedRangeOrBuilder(int index)

      `repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;`
      Specified by:
        `getReservedRangeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedNameList

          public ProtocolStringList getReservedNameList()

           Reserved field names, which may not be used by fields in the same message.
           A given name may only be reserved once.

      `repeated string reserved_name = 10;`
      Specified by:
        `getReservedNameList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedNameCount

          public int getReservedNameCount()

           Reserved field names, which may not be used by fields in the same message.
           A given name may only be reserved once.

      `repeated string reserved_name = 10;`
      Specified by:
        `getReservedNameCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedName

          public java.lang.String getReservedName(int index)

           Reserved field names, which may not be used by fields in the same message.
           A given name may only be reserved once.

      `repeated string reserved_name = 10;`
      Specified by:
        `getReservedName` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### getReservedNameBytes

          public ByteString getReservedNameBytes(int index)

           Reserved field names, which may not be used by fields in the same message.
           A given name may only be reserved once.

      `repeated string reserved_name = 10;`
      Specified by:
        `getReservedNameBytes` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

    - #### isInitialized

          public final boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

      Specified by:
        `isInitialized` in interface `MessageLiteOrBuilder`
      Overrides:
        `isInitialized` in class `GeneratedMessageV3`

    - #### writeTo

          public void writeTo(CodedOutputStream output)
                       throws java.io.IOException

      Description copied from interface: `MessageLite`
      Serializes the message and writes it to `output`. This does not flush or close the stream.
      Specified by:
        `writeTo` in interface `MessageLite`
      Overrides:
        `writeTo` in class `GeneratedMessageV3`
      Throws:
        `java.io.IOException`

    - #### getSerializedSize

          public int getSerializedSize()

      Description copied from interface: `MessageLite`
      Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that.
      Specified by:
        `getSerializedSize` in interface `MessageLite`
      Overrides:
        `getSerializedSize` in class `GeneratedMessageV3`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Description copied from interface: `Message`
      Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.
      Specified by:
        `equals` in interface `Message`
      Overrides:
        `equals` in class `AbstractMessage`
      Parameters:
        `obj` - object to be compared for equality with this message
      Returns:
        `true` if the specified object is equal to this message

    - #### hashCode

          public int hashCode()

      Description copied from interface: `Message`
      Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.
      Specified by:
        `hashCode` in interface `Message`
      Overrides:
        `hashCode` in class `AbstractMessage`
      Returns:
        the hash code value for this message
      See Also:
        `Map.hashCode()`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(java.nio.ByteBuffer data)
                                                            throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(java.nio.ByteBuffer data,
                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(ByteString data)
                                                            throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(ByteString data,
                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(byte[] data)
                                                            throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(byte[] data,
                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(java.io.InputStream input)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(java.io.InputStream input,
                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseDelimitedFrom

          public static DescriptorProtos.DescriptorProto parseDelimitedFrom(java.io.InputStream input)
                                                                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseDelimitedFrom

          public static DescriptorProtos.DescriptorProto parseDelimitedFrom(java.io.InputStream input,
                                                            ExtensionRegistryLite extensionRegistry)
                                                                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(CodedInputStream input)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.DescriptorProto parseFrom(CodedInputStream input,
                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### newBuilderForType

          public DescriptorProtos.DescriptorProto.Builder newBuilderForType()

      Description copied from interface: `MessageLite`
      Constructs a new builder for a message of the same type as this message.
      Specified by:
        `newBuilderForType` in interface `Message`
      Specified by:
        `newBuilderForType` in interface `MessageLite`

    - #### newBuilder

          public static DescriptorProtos.DescriptorProto.Builder newBuilder()

    - #### newBuilder

          public static DescriptorProtos.DescriptorProto.Builder newBuilder(DescriptorProtos.DescriptorProto prototype)

    - #### toBuilder

          public DescriptorProtos.DescriptorProto.Builder toBuilder()

      Description copied from interface: `MessageLite`
      Constructs a builder initialized with the current message. Use this to derive a new message from the current one.
      Specified by:
        `toBuilder` in interface `Message`
      Specified by:
        `toBuilder` in interface `MessageLite`

    - #### newBuilderForType

          protected DescriptorProtos.DescriptorProto.Builder newBuilderForType(GeneratedMessageV3.BuilderParent parent)

      Description copied from class: `GeneratedMessageV3`
      TODO(xiaofeng): remove this together with GeneratedMessageV3.BuilderParent.
      Specified by:
        `newBuilderForType` in class `GeneratedMessageV3`

    - #### getDefaultInstance

          public static DescriptorProtos.DescriptorProto getDefaultInstance()

    - #### parser

          public static Parser<DescriptorProtos.DescriptorProto> parser()

    - #### getParserForType

          public Parser<DescriptorProtos.DescriptorProto> getParserForType()

      Description copied from interface: `MessageLite`
      Gets the parser for a message of the same type as this message.
      Specified by:
        `getParserForType` in interface `Message`
      Specified by:
        `getParserForType` in interface `MessageLite`
      Overrides:
        `getParserForType` in class `GeneratedMessageV3`

    - #### getDefaultInstanceForType

          public DescriptorProtos.DescriptorProto getDefaultInstanceForType()

      Description copied from interface: `MessageLiteOrBuilder`
      Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.
      Specified by:
        `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
      Specified by:
        `getDefaultInstanceForType` in interface `MessageOrBuilder`